title: VIS IWS HK Parameter Chooser
author: M.Whillock@ucl.ac.uk
date: 23 Apr 2020

Copyright © 2020 University College London / MSSL

--


# Introduction


This a mini user guide to the VIS IWS TM HK Control Centre (hk_cc.py) program.

## Prerequisites

* python3
* git

## Installation: Online Deployment

TBD

## Installation: Offline Deployment

The HK Control Centre program is currently bundled in with the TM HK Monitor program.

If this has not alrady been done then choose a location to untar the HKTM_monitor gzipped tar file and untar it.

`tar xvfz HKTM_monitor.tar.gz`

Change directory into the new directory:

`cd HKTM_monitor`

The program currently expects there to be a diretory at:

`${HOME}/Euclid/Data/Hk/CCS`

to store the cataloged files.


## HK Control Centre

This program requires the conda environment IWSop to be set:

`conda activate IWSop`

### Launching
In an xterm change directory to where the program is installed.
This document assumes that python3 is run using the `python` command.
Use whatever command is required to run python3 on your system.

Launch the program:

`python hk_cc.py`

The main window will appear:

![hk_cc.py main window](../Pictures/hk_cc/hk_cc.png)


### Operation

The HK Control Centre program has three functions:

* Managing CCS data sources.
* Cataloging CCS data sources.
* Providing an interface to launch the HK Playback graphing program.

#### Managing CCS Data Sources

This is the scope of the left-hand panel labelled ***Data Source***.

A new CCS data source can be selected by pressing the ***Browse*** button in the panel.
A file select dialog box will be presented so the user can navigate to and select a .csv data source. When the file is selected it will be listed in the ***Data Source*** panel.

Existing data sources listed in the ***Data Source*** panel can be deleted by selecting the list entry and pressing the 'Delete' button.
Note that this operation removes the reference displayed in the ***Data Source*** panel list but does not remove the actual file from the filesystem.
To physically remove the file from the filesystem requires the linux `rm` command to be used in an xterm.

#### Catalog 

This function is spread over the left-hand and centre panels, labelled ***Data Source*** and ***Catalog***.

The purpose of the catalog is to make a copy of the CCS source file in a reserved directory and to generate a list of the start and end times of the original file.
The entries in the ***Catalog*** panel are the names of the files in the catalog.
Selecting an entry in the ***Catalog*** list panel will update the information shown below the list; this shows the actual location of the file, the date and time of the first data in the file and the date and time of the last data in the file.

To add files to the catalog select a source CCS file in the ***Data Source*** panel and then press the ***Catalog*** button.
A message will appear in the bottom left corner of the window indicating whether the cataloging was successful or not.


#### Playback

This function is spread over the centre and right-hand panels.
The purpose of this fuction is to launch the ***HK Playback*** program to graph parameters in files selected from the ***Catalog*** panel.
The ***Playback*** panel listbox presents configuration files generated from using the ***parameter_lister1.py*** program (see ***parameter\_lister1\_um.pdf*** to see how to generate the required configuration files).
The configuration files consist of groups of parameters to be plotted on multiple plots.
To generate a file playback plot select a file from the ***Catalog*** list box and then click the ***Open Playback*** button.
This will launch the ***hk_playback*** program (see the user manual ***hk\_playback\_um.pdf***).

The ***Refresh*** button will update the ***Playback*** panel listbox after a new file has been cataloged.


#### Future Work

- Adapt the catalog to rename the CCS source files to something more sensible.
- Make the ***Delete*** button actually remove the file from the filesystem.
