#!/bin/sh

# extract_timing.sh csv_data_file catalog_directory
ret=0

# Need two arguments, both of which must exist
if [ ${#} -eq 2 ] ; then

    # First needs to be a file
    if [ -f ${1} ] ; then

	# Second needs to be a directory
	if [ -d ${2} ] ; then

	    # Check the file is .csv
	    # .CSV not checked yet
	    suffix=${1##*.}

	    if [ ${suffix} = "csv" ] ; then
		# Suffix is ok

		# get filename only into fn
		fn=${1%.csv}
		fn=${fn##*/}

		# Add timing to filename
		ofn="${fn}"_timing.txt

		# Extract info from csv file
		foo=$(awk -f ./extract_timing.awk ${1})
		start_time=${foo%,*}
		end_time=${foo#*,}

		# Put the timing info into the timing file
		echo Putting ${1}, ${start_time}, ${end_time} into ${2}${ofn}
		echo ${1}, ${start_time}, ${end_time} > ${2}${ofn}
		
	    else
		echo Filename must end in .csv
		ret=1
	    fi

	else
	    echo Parameter 2 must be a directory
	    ret=2
	fi
	
    else
	echo Parameter 1 must be a .csv file
	ret=3
    fi

else
    echo "Give me a file and a directory you numpty."
    ret=4
fi
exit ${ret}

