
import sys

from PyQt5 import QtWidgets, QtCore, QtGui      #, uic, QtQml, QtQuick
from PyQt5.QtCore import Qt

from Euclid import iws_defs, iws

PARAMETER_LABEL_XSTART = 10
LABEL_YSTART = 5
PARAMETER_LABEL_WIDTH = 190
VALUE_LABEL_WIDTH = 139
LABEL_HEIGHT = 16
OFFSET = LABEL_HEIGHT + 2

PARAMETER_LABEL = 0
VALUE_LABEL     = 1

#class fpga(QtWidgets.QWidget):
class rt_slow(object):

    #def __init__(self, tabWidget):
    def __init__(self, mainWindow):

        super(rt_slow, self).__init__()
        self.mainWindow = mainWindow
        #self.tabWidget = mainWindow.ui.tab_rt_slow
        self.tabWidget = None#= mainWindow.tabWidget
        self.labels = iws.read_parameters(iws_defs.proto3_test_parameter_file)
        #self.labels = iws.read_parameters_as_dictionary(iws_defs.proto3_test_parameter_file)
        self.parameter_labels = []
        self.parameter_values = []
        self.parameters = {}

    #def parameters(self):
        #return self.parameters
    
    def debug(self):
        #for key in self.labels.items():
            #print("Label = " + key + "\n")
        for line in self.labels:
            print("label: %s %s %s\n" % (line[0], line[1], line[2]))

# Labels: VIS_CDPU_5V_CPU VDGT2712 VOGY882800 rt_slow
    def setupUi(self):
        self.tabWidget = self.mainWindow.gridLayout
        #x = 0
        #for key in self.labels.items():
            #self.makeLabel(self.tabWidget, x, key, PARAMETER_LABEL)
            #self.makeLabel(self.tabWidget, x)
            #x += 1
        for x in range(0, 20):
            parameter = self.labels[x][0]
            self.makeLabel(self.tabWidget, x, parameter, PARAMETER_LABEL)
            self.makeLabel(self.tabWidget, x, '')
            parameter = self.labels[x][1]
            self.parameters[parameter] = (self.parameter_labels[x], self.parameter_values[x])
            
    #def makeLabel(self, label, x, label_type=VALUE_LABEL):
    def makeLabel(self, tabWidget, x, labelString, label_type=VALUE_LABEL):
        print("Making label for number %d\n" % x)
        #######label = QtWidgets.QLabel(tabWidget)
        label = QtWidgets.QLabel(self.mainWindow.tab)
        #labelName = self.labels[x][0]
        labelName = labelString

        label.setStyleSheet("QLabel[stat=warn] {background-color: yellow; color: black;} QLabel[stat=ok] {background-color: green; color: white;} QLabel[stat=ool] {background-color: red; color: white}")
        label.setProperty('stat', 'ok')
        
        if label_type == PARAMETER_LABEL:
            ###label.setGeometry(QtCore.QRect(PARAMETER_LABEL_XSTART, LABEL_YSTART + (x * OFFSET), PARAMETER_LABEL_WIDTH, LABEL_HEIGHT))
            label.setGeometry(QtCore.QRect(0, 0, 20, 8))
            label.setObjectName(labelName)
            label.setText(labelName)
            self.parameter_labels.append(label)
            tabWidget.addWidget(label, x, 0, 1, 1)
            tabWidget.setColumnStretch(x, 1)
            tabWidget.setRowStretch(x, 1)
        else:
            ###label.setGeometry(QtCore.QRect(PARAMETER_LABEL_XSTART + PARAMETER_LABEL_WIDTH, LABEL_YSTART + (x * OFFSET), VALUE_LABEL_WIDTH, LABEL_HEIGHT))
            label.setGeometry(QtCore.QRect(0, 0, 20, 16))
            label.setObjectName(labelName + "Value")
            label.setText("Parameter value")
            label.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)
            self.parameter_values.append(label)
            tabWidget.addWidget(label, x, 1, 1, 1)
            tabWidget.setColumnStretch(x, 1)
            tabWidget.setRowStretch(x, 1)

        font = QtGui.QFont()
        font.setPointSize(9)
        font.setBold(True)
        font.setWeight(75)
        label.setFont(font)
